# File: dpdlOCamlTest2.h
#
# Example: This Dpdl script executes embedded OCaml code
#
# (c)opyright 2009
# SEE Solutions
#
# e-mail: info@dpdl.io
#
#

# main
println("testing Dpdl embedded OCaml...")

dpdl_stack_push("dpdl:compile")

>>ocaml
let num_domains = 2
let n = 20

let rec fib n =
  if n < 2 then 1
  else fib (n-1) + fib (n-2)

let rec fib_par n d =
  if d <= 1 then fib n
  else
    let a = fib_par (n-1) (d-1) in
    let b = Domain.spawn (fun _ -> fib_par (n-2) (d-1)) in
    a + Domain.join b

let () =
  let res = fib_par n num_domains in
  Printf.printf "fib(%d) = %d\n" n res

<<

int exit_code = dpdl_exit_code()

println("embedded OCaml exit code: " + exit_code)
